package com.example.demo;

import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.util.retry.Retry;

import java.time.Duration;
import java.util.stream.Collectors;

public class FluxToMonoOperators {

    public static void main(String[] args) {
        Flux<Integer> flux = Flux.just( 1, 4, 5, 2, 0, 10 );
        Flux<Integer> flux1 = Flux.just( 100 );

        flux.next().log().subscribe(System.out::println);

        flux.last().log().subscribe(System.out::println);


        Mono<Integer> m = Mono.from(flux).log();
        m.subscribe();

        flux.single().log().subscribe(System.out::println);
        flux1.single().log().subscribe(System.out::println);
        flux1.single(15).log().subscribe(System.out::println);
        Flux.just().singleOrEmpty().log().subscribe(System.out::println);


        flux.elementAt(3).log().subscribe(System.out::println);
        flux.elementAt(8, 15 ).log().subscribe(System.out::println);

        flux.any( integer -> integer <= 0 ).log().subscribe(System.out::println);
        flux.all( integer -> integer > 0 ).log().subscribe(System.out::println);

        flux.shareNext().log().subscribe(System.out::println);

        flux.collect(Collectors.reducing( (i1, i2) -> i1 )).log().subscribe(System.out::println);

        flux.collect(Collectors.reducing( (i1, i2) -> i1 )).map( o -> o.get() ).log().subscribe(System.out::println);

    }

}
