package com.example.demo;

import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.time.Duration;

public class MonoErrorMethods {

    public static void main(String[] args) {

        // block
        Mono.delay(Duration.ofSeconds(2))
                .then(Mono.just("Krishna"))
                .log()
                .block(Duration.ofSeconds(3));

        Mono.just( 100 )
                .map( x -> x/0 )
                .log()
                .onErrorReturn( 100 ).log();

        Mono.just( 100 )
                .map( x -> x/0 )
                .log()
                .onErrorResume( ex -> Mono.empty() ).log();

        Mono.just( 100 )
                .map( x -> x/0 )
                .log()
                .onErrorComplete( RuntimeException.class ).log();

        Mono.just( 100 )
                .map( x -> x/0 )
                .log()
                .onErrorContinue( RuntimeException.class, (throwable, o) -> System.out.println( throwable.toString() ) ).log();

        Mono.just( 100 )
                .map( x -> x/0 )
                .log()
                .onErrorMap( ex -> new RuntimeException("we messed up somewhere") ).log();

        Mono.just( 100 )
                .map( x -> x/0 )
                .log()
                .doOnError( ex -> new RuntimeException("we messed up somewhere") ).log();

        Mono.just( 100 )
                .map( x -> x/0 )
                .log()
                .retry(3)
                .log();

    }

}
